From 6f257a85e70f0cb47f0c8b0b5a823dcc374f092e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 27 2020 20:12:06 +0000
Subject: [PATCH 1796/2232] Merge pull request #595 from dtolnay/layout


Emit private layout struct for all opaque types
---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 86fd491..0083525 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -132,6 +132,7 @@ fn write_functions<'a>(out: &mut OutFile<'a>, apis: &'a [Api]) {
         for api in apis {
             match api {
                 Api::Struct(strct) => write_struct_operator_decls(out, strct),
+                Api::RustType(ety) => write_opaque_type_layout_decls(out, ety),
                 Api::CxxFunction(efn) => write_cxx_function_shim(out, efn),
                 Api::RustFunction(efn) => write_rust_function_decl(out, efn),
                 _ => {}
@@ -144,6 +145,7 @@ fn write_functions<'a>(out: &mut OutFile<'a>, apis: &'a [Api]) {
     for api in apis {
         match api {
             Api::Struct(strct) => write_struct_operators(out, strct),
+            Api::RustType(ety) => write_opaque_type_layout(out, ety),
             Api::RustFunction(efn) => {
                 out.next_section();
                 write_rust_function_shim(out, efn);
@@ -311,22 +313,32 @@ fn write_opaque_type<'a>(out: &mut OutFile<'a>, ety: &'a ExternType, methods: &[
     for line in ety.doc.to_string().lines() {
         writeln!(out, "//{}", line);
     }
+
     out.builtin.opaque = true;
-    write!(
+    writeln!(
         out,
         "struct {} final : public ::rust::Opaque {{",
         ety.name.cxx,
     );
+
     for method in methods {
-        write!(out, "\n  ");
+        write!(out, "  ");
         let sig = &method.sig;
         let local_name = method.name.cxx.to_string();
         write_rust_function_shim_decl(out, &local_name, sig, false);
-        write!(out, ";");
+        writeln!(out, ";");
     }
+
     if !methods.is_empty() {
         writeln!(out);
     }
+
+    out.include.cstddef = true;
+    writeln!(out, "private:");
+    writeln!(out, "  struct layout {{");
+    writeln!(out, "    static ::std::size_t size() noexcept;");
+    writeln!(out, "    static ::std::size_t align() noexcept;");
+    writeln!(out, "  }};");
     writeln!(out, "}};");
     writeln!(out, "#endif // {}", guard);
 }
@@ -568,6 +580,47 @@ fn write_struct_operators<'a>(out: &mut OutFile<'a>, strct: &'a Struct) {
     }
 }
 
+fn write_opaque_type_layout_decls<'a>(out: &mut OutFile<'a>, ety: &'a ExternType) {
+    out.set_namespace(&ety.name.namespace);
+    out.begin_block(Block::ExternC);
+
+    let link_name = mangle::operator(&ety.name, "sizeof");
+    writeln!(out, "::std::size_t {}() noexcept;", link_name);
+
+    let link_name = mangle::operator(&ety.name, "alignof");
+    writeln!(out, "::std::size_t {}() noexcept;", link_name);
+
+    out.end_block(Block::ExternC);
+}
+
+fn write_opaque_type_layout<'a>(out: &mut OutFile<'a>, ety: &'a ExternType) {
+    if out.header {
+        return;
+    }
+
+    out.set_namespace(&ety.name.namespace);
+
+    out.next_section();
+    let link_name = mangle::operator(&ety.name, "sizeof");
+    writeln!(
+        out,
+        "::std::size_t {}::layout::size() noexcept {{",
+        ety.name.cxx,
+    );
+    writeln!(out, "  return {}();", link_name);
+    writeln!(out, "}}");
+
+    out.next_section();
+    let link_name = mangle::operator(&ety.name, "alignof");
+    writeln!(
+        out,
+        "::std::size_t {}::layout::align() noexcept {{",
+        ety.name.cxx,
+    );
+    writeln!(out, "  return {}();", link_name);
+    writeln!(out, "}}");
+}
+
 fn write_cxx_function_shim<'a>(out: &mut OutFile<'a>, efn: &'a ExternFn) {
     out.next_section();
     out.set_namespace(&efn.name.namespace);
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 96cd15a..69c90eb 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -55,7 +55,10 @@ fn expand(ffi: Module, apis: &[Api], types: &Types) -> TokenStream {
             Api::CxxFunction(efn) => {
                 expanded.extend(expand_cxx_function_shim(efn, types));
             }
-            Api::RustType(ety) => expanded.extend(expand_rust_type_impl(ety)),
+            Api::RustType(ety) => {
+                expanded.extend(expand_rust_type_impl(ety));
+                hidden.extend(expand_rust_type_layout(ety));
+            }
             Api::RustFunction(efn) => hidden.extend(expand_rust_function_shim(efn, types)),
             Api::TypeAlias(alias) => {
                 expanded.extend(expand_type_alias(alias));
@@ -681,6 +684,30 @@ fn expand_rust_type_assert_sized(ety: &ExternType) -> TokenStream {
     }
 }
 
+fn expand_rust_type_layout(ety: &ExternType) -> TokenStream {
+    let ident = &ety.name.rust;
+    let span = ident.span();
+
+    let link_sizeof = mangle::operator(&ety.name, "sizeof");
+    let link_alignof = mangle::operator(&ety.name, "alignof");
+
+    let local_sizeof = format_ident!("__sizeof_{}", ety.name.rust);
+    let local_alignof = format_ident!("__alignof_{}", ety.name.rust);
+
+    quote_spanned! {span=>
+        #[doc(hidden)]
+        #[export_name = #link_sizeof]
+        extern "C" fn #local_sizeof() -> usize {
+            ::std::mem::size_of::<#ident>()
+        }
+        #[doc(hidden)]
+        #[export_name = #link_alignof]
+        extern "C" fn #local_alignof() -> usize {
+            ::std::mem::align_of::<#ident>()
+        }
+    }
+}
+
 fn expand_rust_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
     let link_name = mangle::extern_fn(efn, types);
     let local_name = match &efn.receiver {
diff --git a/tests/ui/opaque_not_sized.stderr b/tests/ui/opaque_not_sized.stderr
index 9818e44..75773b6 100644
--- a/tests/ui/opaque_not_sized.stderr
+++ b/tests/ui/opaque_not_sized.stderr
@@ -9,3 +9,21 @@ error[E0277]: the size for values of type `str` cannot be known at compilation t
   |
   = help: within `TypeR`, the trait `Sized` is not implemented for `str`
   = note: required because it appears within the type `TypeR`
+
+error[E0277]: the size for values of type `str` cannot be known at compilation time
+   --> $DIR/opaque_not_sized.rs:4:14
+    |
+4   |         type TypeR;
+    |              ^^^^^ doesn't have a size known at compile-time
+    |
+    = help: within `TypeR`, the trait `Sized` is not implemented for `str`
+    = note: required because it appears within the type `TypeR`
+
+error[E0277]: the size for values of type `str` cannot be known at compilation time
+   --> $DIR/opaque_not_sized.rs:4:14
+    |
+4   |         type TypeR;
+    |              ^^^^^ doesn't have a size known at compile-time
+    |
+    = help: within `TypeR`, the trait `Sized` is not implemented for `str`
+    = note: required because it appears within the type `TypeR`

